/*
 * main.c  -- entry point
 *
 * $Id: main.c,v 1.6 2004/05/18 12:28:04 hos Exp $
 *
 */


#include <string.h>
#include "main.h"


HINSTANCE instance = NULL;

BOOL APIENTRY DllMain(HANDLE module, DWORD reason, LPVOID reserve)
{
    if(reason == DLL_PROCESS_ATTACH) {
        instance = (HINSTANCE)module;
    }

    return TRUE;
}


void error_message(char *str, int code)
{
    TCHAR buf[256];

    wsprintf(buf, _T("%s: 0x%x"), str, code);
    MessageBox(NULL, buf, _T("ie migemo search"), MB_ICONERROR | MB_OK);
}


static BOOL CALLBACK enum_html_doc_wnd(HWND hwnd, LPARAM param)
{
    TCHAR buf[256];

    if(GetClassName(hwnd, buf, 256) == 0) {
        return TRUE;
    }

    if(_tcscmp(buf, _T("Internet Explorer_Server")) != 0) {
        return TRUE;
    }

    *((HWND *)param) = hwnd;
    return FALSE;
}

static HRESULT get_fg_html_doc(IHTMLDocument2 **doc, HWND *hwnd)
{
    HWND fg_hwnd, doc_hwnd;
    UINT getobj_msg;
    LRESULT lret, res;
    HRESULT hret;

    fg_hwnd = GetForegroundWindow();
    if(fg_hwnd == NULL) {
        return E_FAIL;
    }

    doc_hwnd = NULL;
    EnumChildWindows(fg_hwnd, enum_html_doc_wnd, (LPARAM)&doc_hwnd);
    if(doc_hwnd == NULL) {
        return E_FAIL;
    }

    getobj_msg = RegisterWindowMessage(_T("WM_HTML_GETOBJECT"));
    if(getobj_msg == 0) {
        return E_FAIL;
    }

    lret = SendMessageTimeout(doc_hwnd, getobj_msg, 0, 0,
                              SMTO_ABORTIFHUNG, 1000,
                              (PDWORD_PTR)&res);
    if(lret == 0) {
        return E_FAIL;
    }

    hret = ObjectFromLresult(res, &IID_IHTMLDocument2, 0, (void **)doc);
    *hwnd = fg_hwnd;

    return hret;
}

static void isearch(int dir, int ignore_case, char *migemo_dict)
{
    HRESULT hres;

    if(strcmp(migemo_dict, "") == 0) {
        migemo_dict = "./dict/migemo-dict";
    }

    hres = CoInitialize(NULL);
    if(FAILED(hres)) {
        error_message("CoInitialize failed", hres);
        return;
    }

    {
        IHTMLDocument2 *doc;
        HWND hwnd;

        hres = get_fg_html_doc(&doc, &hwnd);
        if(FAILED(hres)) {
            error_message("IHTMLDocument2 not found", hres);
            goto func_end;
        }

        isearch_html_doc(doc, hwnd, dir, ignore_case, migemo_dict);

        IHTMLDocument2_Release(doc);
    }

  func_end:

    CoUninitialize();
}


void WINAPI mayuisearch_forward(char *param)
{
    isearch(+1, 1, param);
}

void WINAPI mayuisearch_backward(char *param)
{
    isearch(-1, 1, param);
}

void WINAPI mayuisearch_forward_cs(char *param)
{
    isearch(+1, 0, param);
}

void WINAPI mayuisearch_backward_cs(char *param)
{
    isearch(-1, 0, param);
}
