/*
 * regexp.h  -- interfaces of VBScript Regular Expression
 *
 * $Id: regexp.h,v 1.2 2004/05/18 09:37:34 hos Exp $
 *
 */

#include <objfwd.h>
#include <wtypes.h>


/* IRegExp */

#ifndef __IRegExp_INTERFACE_DEFINED__
#define __IRegExp_INTERFACE_DEFINED__

EXTERN_C const IID IID_IRegExp;
EXTERN_C const CLSID CLSID_RegExp;

#undef INTERFACE
#define INTERFACE IRegExp
DECLARE_INTERFACE_(IRegExp, IDispatch)
{
    STDMETHOD(QueryInterface)(THIS_ REFIID, PVOID *) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT *) PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo **) PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID, LPOLESTR *, UINT, LCID, DISPID *) PURE;
    STDMETHOD(Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *) PURE;

    STDMETHOD(get_Pattern)(THIS_ BSTR *) PURE;
    STDMETHOD(put_Pattern)(THIS_ BSTR) PURE;
    STDMETHOD(get_IgnoreCase)(THIS_ VARIANT_BOOL *) PURE;
    STDMETHOD(put_IgnoreCase)(THIS_ VARIANT_BOOL) PURE;
    STDMETHOD(get_Global)(THIS_ VARIANT_BOOL *) PURE;
    STDMETHOD(put_Global)(THIS_ VARIANT_BOOL) PURE;
    STDMETHOD(Execute)(THIS_ BSTR, IDispatch **) PURE;
    STDMETHOD(Test)(THIS_ BSTR, VARIANT_BOOL *) PURE;
    STDMETHOD(Replace)(THIS_ BSTR, BSTR, BSTR *) PURE;
};

#ifdef COBJMACROS
#define IRegExp_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IRegExp_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IRegExp_Release(p) (p)->lpVtbl->Release(p)
#define IRegExp_GetTypeInfoCount(p,a) (p)->lpVtbl->GetTypeInfoCount(p,a)
#define IRegExp_GetTypeInfo(p,a,b,c) (p)->lpVtbl->GetTypeInfo(p,a,b,c)
#define IRegExp_GetIDsOfNames(p,a,b,c,d,e) (p)->lpVtbl->GetIDsOfNames(p,a,b,c,d,e)
#define IRegExp_Invoke(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->Invoke(p,a,b,c,d,e,f,g,h)
#define IRegExp_get_Pattern(p,a) (p)->lpVtbl->get_Pattern(p,a)
#define IRegExp_put_Pattern(p,a) (p)->lpVtbl->put_Pattern(p,a)
#define IRegExp_get_IgnoreCase(p,a) (p)->lpVtbl->get_IgnoreCase(p,a)
#define IRegExp_put_IgnoreCase(p,a) (p)->lpVtbl->put_IgnoreCase(p,a)
#define IRegExp_get_Global(p,a) (p)->lpVtbl->get_Global(p,a)
#define IRegExp_put_Global(p,a) (p)->lpVtbl->put_Global(p,a)
#define IRegExp_Execute(p,a,b) (p)->lpVtbl->Execute(p,a,b)
#define IRegExp_Test(p,a,b) (p)->lpVtbl->Test(p,a,b)
#define IRegExp_Replace(p,a,b,c) (p)->lpVtbl->Release(p,a,b,c)
#endif /* COBJMACROS */

#endif /* __IRegExp_INTERFACE_DEFINED__ */


/* IMatch */

#ifndef __IMatch_INTERFACE_DEFINED__
#define __IMatch_INTERFACE_DEFINED__

EXTERN_C const IID IID_IMatch;
EXTERN_C const CLSID CLSID_Match;

#undef INTERFACE
#define INTERFACE IMatch
DECLARE_INTERFACE_(IMatch, IDispatch)
{
    STDMETHOD(QueryInterface)(THIS_ REFIID, PVOID *) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT *) PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo **) PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID, LPOLESTR *, UINT, LCID, DISPID *) PURE;
    STDMETHOD(Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *) PURE;

    STDMETHOD(get_Value)(THIS_ BSTR *) PURE;
    STDMETHOD(get_FirstIndex)(THIS_ long *) PURE;
    STDMETHOD(get_Length)(THIS_ long *) PURE;
};

#ifdef COBJMACROS
#define IMatch_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IMatch_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IMatch_Release(p) (p)->lpVtbl->Release(p)
#define IMatch_GetTypeInfoCount(p,a) (p)->lpVtbl->GetTypeInfoCount(p,a)
#define IMatch_GetTypeInfo(p,a,b,c) (p)->lpVtbl->GetTypeInfo(p,a,b,c)
#define IMatch_GetIDsOfNames(p,a,b,c,d,e) (p)->lpVtbl->GetIDsOfNames(p,a,b,c,d,e)
#define IMatch_Invoke(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->Invoke(p,a,b,c,d,e,f,g,h)
#define IMatch_get_Value(p,a) (p)->lpVtbl->get_Value(p,a)
#define IMatch_get_FirstIndex(p,a) (p)->lpVtbl->get_FirstIndex(p,a)
#define IMatch_get_Length(p,a) (p)->lpVtbl->get_Length(p,a)
#endif /* COBJMACROS */

#endif /* __IMatch_INTERFACE_DEFINED__ */


/* IMatchCollection */

#ifndef __IMatchCollection_INTERFACE_DEFINED__
#define __IMatchCollection_INTERFACE_DEFINED__

EXTERN_C const IID IID_IMatchCollection;
EXTERN_C const CLSID CLSID_MatchCollection;

#undef INTERFACE
#define INTERFACE IMatchCollection
DECLARE_INTERFACE_(IMatchCollection, IDispatch)
{
    STDMETHOD(QueryInterface)(THIS_ REFIID, PVOID *) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT *) PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo **) PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID, LPOLESTR *, UINT, LCID, DISPID *) PURE;
    STDMETHOD(Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *) PURE;

    STDMETHOD(get_Item)(THIS_ long, IDispatch **) PURE;
    STDMETHOD(get_Count)(THIS_ long *) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown **) PURE;
};

#ifdef COBJMACROS
#define IMatchCollection_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define IMatchCollection_AddRef(p) (p)->lpVtbl->AddRef(p)
#define IMatchCollection_Release(p) (p)->lpVtbl->Release(p)
#define IMatchCollection_GetTypeInfoCount(p,a) (p)->lpVtbl->GetTypeInfoCount(p,a)
#define IMatchCollection_GetTypeInfo(p,a,b,c) (p)->lpVtbl->GetTypeInfo(p,a,b,c)
#define IMatchCollection_GetIDsOfNames(p,a,b,c,d,e) (p)->lpVtbl->GetIDsOfNames(p,a,b,c,d,e)
#define IMatchCollection_Invoke(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->Invoke(p,a,b,c,d,e,f,g,h)
#define IMatchCollection_get_Item(p,a,b) (p)->lpVtbl->get_Item(p,a,b)
#define IMatchCollection_get_Count(p,a) (p)->lpVtbl->get_Count(p,a)
#define IMatchCollection_get__NewEnum(p,a) (p)->lpVtbl->get__NewEnum(p,a)
#endif /* COBJMACROS */

#endif /* __IMatchCollection_INTERFACE_DEFINED__ */
